VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsOneRelay"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Private Enum USB_Relay_Device_Type
    USB_RELAY_DEVICE_ONE_CHANNEL = 1&
    USB_RELAY_DEVICE_TWO_CHANNEL = 2&
    USB_RELAY_DEVICE_FOUR_CHANNEL = 4&
    USB_RELAY_DEVICE_EIGHT_CHANNEL = 8&
End Enum

Private Type USB_Relay_Device_Info
    Serial_Number As Long
    Device_Path   As Long
    Device_Type   As Long   'USB_Relay_Device_Type
    Next          As Long
End Type


Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (pDest As Any, pSource As Any, ByVal ByteLen As Long)

Private Declare Function usb_relay_device_close_all_relay_channel CDecl Lib "usb_relay_device.dll" (ByVal hHandle As Long) As Long
Private Declare Function usb_relay_device_close_one_relay_channel CDecl Lib "usb_relay_device.dll" (ByVal hHandle As Long, ByVal Index As Long) As Long

Private Declare Function usb_relay_device_open_all_relay_channel CDecl Lib "usb_relay_device.dll" (ByVal hHandle As Long) As Long
Private Declare Function usb_relay_device_open_one_relay_channel CDecl Lib "usb_relay_device.dll" (ByVal hHandle As Long, ByVal Index As Long) As Long

Private Declare Function usb_relay_device_enumerate CDecl Lib "usb_relay_device.dll" () As Long
Private Declare Sub usb_relay_device_free_enumerate CDecl Lib "usb_relay_device.dll" (ByVal Device_Info As Long)

Private Declare Function usb_relay_device_set_serial CDecl Lib "usb_relay_device.dll" (ByVal hHandle As Long, ByVal Serial As Any) As Long

Private Declare Function usb_relay_exit CDecl Lib "usb_relay_device.dll" () As Long
Private Declare Function usb_relay_init CDecl Lib "usb_relay_device.dll" () As Long
Private Declare Sub usb_relay_device_close CDecl Lib "usb_relay_device.dll" (ByVal hHandle As Long)

Private Declare Function usb_relay_device_open CDecl Lib "usb_relay_device.dll" (ByVal Device_Info As Long) As Long
Private Declare Function usb_relay_device_open_with_serial_number CDecl Lib "usb_relay_device.dll" (ByVal Serial_Number As Long, ByVal Length As Integer) As Long

Private Declare Function usb_relay_device_get_status CDecl Lib "usb_relay_device.dll" (ByVal hHandle As Long, ByRef Status As Long) As Long


Private mvardevice_info_PTR As Long 'local copy
Private mvarSerial_Number_PTR As Long 'local copy
Private mvarSerial_Number As String 'local copy
Private mvarDevice_Path As String 'local copy
Private mvarRelay_Type As Long 'local copy
Private mvarRelay_Status As Long 'local copy


Public Property Get Device_Info_PTR() As Long
    Device_Info_PTR = mvardevice_info_PTR
End Property
Public Property Let Device_Info_PTR(vData As Long)
    mvardevice_info_PTR = vData
End Property

Public Property Get Serial_Number_PTR() As Long
    Serial_Number_PTR = mvarSerial_Number_PTR
End Property
Public Property Let Serial_Number_PTR(vData As Long)
    mvarSerial_Number_PTR = vData
End Property

Public Property Get Relay_Type() As Long
    Relay_Type = mvarRelay_Type
End Property
Public Property Let Relay_Type(vData As Long)
    mvarRelay_Type = vData
End Property

Public Property Get Device_Path() As String
    Device_Path = mvarDevice_Path
End Property
Public Property Let Device_Path(vData As String)
    mvarDevice_Path = vData
End Property


Public Property Get Serial_Number() As String
    Serial_Number = mvarSerial_Number
End Property
Public Property Let Serial_Number(vData As String)
    mvarSerial_Number = vData
End Property

Public Property Let Relay_Status(vData As Long)
    mvarRelay_Status = vData
End Property

Public Property Get Relay_One_Status(ByVal Num_Relay As Long) As Long





    Relay_One_Status = 0
    Select Case Num_Relay
        Case 1:     If (mvarRelay_Status And &H1) = &H1 Then Relay_One_Status = 1
        Case 2:     If (mvarRelay_Status And &H2) = &H2 Then Relay_One_Status = 1
        Case 3:     If (mvarRelay_Status And &H4) = &H4 Then Relay_One_Status = 1
        Case 4:     If (mvarRelay_Status And &H8) = &H8 Then Relay_One_Status = 1
        Case 5:     If (mvarRelay_Status And &H10) = &H10 Then Relay_One_Status = 1
        Case 6:     If (mvarRelay_Status And &H20) = &H20 Then Relay_One_Status = 1
        Case 7:     If (mvarRelay_Status And &H40) = &H40 Then Relay_One_Status = 1
        Case 8:     If (mvarRelay_Status And &H80) = &H80 Then Relay_One_Status = 1
    End Select
End Property







Public Sub Relay_Switch(ByVal nRelay As Long, Optional ByVal nAction As String = "off")
    Dim nHandle As Long
    Dim s As String
    
    s = WToA(mvarSerial_Number, CP_ACP)

    nHandle = usb_relay_device_open_with_serial_number(StrPtr(s), Len(s))

    If Not (nHandle > 0) Then
        Debug.Print "Error Relay_Switch: Error open device."
        Exit Sub
    End If

    If Len(nAction) = 0 Then
        Debug.Print "Error Relay_Switch: No Action."
        Exit Sub
    End If


    Dim nRet_Relay_Action As Long
    
    
    
    Select Case nAction
    Case "on"
        nRet_Relay_Action = usb_relay_device_open_one_relay_channel(nHandle, nRelay)
    Case "off"
        nRet_Relay_Action = usb_relay_device_close_one_relay_channel(nHandle, nRelay)
        
    Case "on_all"
        
        nRet_Relay_Action = usb_relay_device_open_all_relay_channel(nHandle)
        
    Case "off_all"
        nRet_Relay_Action = usb_relay_device_close_all_relay_channel(nHandle)
        
    
    
    Case "switch"
    
    
    End Select

    Debug.Print "nRet_Relay_Action(" & nAction & "): " & IIf(nRet_Relay_Action = 0, "success", "error")

'    /*open/close a relay channel on the USB-Relay-Device
'    @paramter: index -- which channel your want to open/close
'    hHandle -- which usb relay device your want to operate
'    @returns: 0 -- success; 1 -- error; 2 -- index is outnumber the number of the usb relay device


    Dim nStatus As Long
    Dim nRet_dev_status As Long
'    status bit: High --> Low 0000 0000 0000 0000 0000 0000 0000 0000, one bit indicate a relay status.
'    the lowest bit 0 indicate relay one status, 1 -- means open status, 0 -- means closed status.
'    bit 0/1/2/3/4/5/6/7/8 indicate relay 1/2/3/4/5/6/7/8 status
'    @returns: 0 -- success; 1 -- error
    nRet_dev_status = usb_relay_device_get_status(nHandle, nStatus)
    mvarRelay_Status = nStatus
    Debug.Print "usb_relay_device_get_status: " & IIf(nRet_dev_status = 0, "success", "error")

    Call usb_relay_device_close(nHandle)

'switch

End Sub















