VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsRelays"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Collection" ,"clsOneRelay"
Attribute VB_Ext_KEY = "Member0" ,"clsOneRelay"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Private Enum USB_Relay_Device_Type
    USB_RELAY_DEVICE_ONE_CHANNEL = 1&
    USB_RELAY_DEVICE_TWO_CHANNEL = 2&
    USB_RELAY_DEVICE_FOUR_CHANNEL = 4&
    USB_RELAY_DEVICE_EIGHT_CHANNEL = 8&
End Enum

Private Type USB_Relay_Device_Info
    Serial_Number As Long
    Device_Path   As Long
    Device_Type   As Long   'USB_Relay_Device_Type
    Next          As Long
End Type


Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (pDest As Any, pSource As Any, ByVal ByteLen As Long)

Private Declare Function usb_relay_device_close_all_relay_channel CDecl Lib "usb_relay_device.dll" (ByVal hHandle As Long) As Long
Private Declare Function usb_relay_device_close_one_relay_channel CDecl Lib "usb_relay_device.dll" (ByVal hHandle As Long, ByVal Index As Long) As Long

Private Declare Function usb_relay_device_open_all_relay_channel CDecl Lib "usb_relay_device.dll" (ByVal hHandle As Long) As Long
Private Declare Function usb_relay_device_open_one_relay_channel CDecl Lib "usb_relay_device.dll" (ByVal hHandle As Long, ByVal Index As Long) As Long

Private Declare Function usb_relay_device_enumerate CDecl Lib "usb_relay_device.dll" () As Long
Private Declare Sub usb_relay_device_free_enumerate CDecl Lib "usb_relay_device.dll" (ByVal Device_Info As Long)

Private Declare Function usb_relay_device_set_serial CDecl Lib "usb_relay_device.dll" (ByVal hHandle As Long, ByVal Serial As Any) As Long

Private Declare Function usb_relay_exit CDecl Lib "usb_relay_device.dll" () As Long
Private Declare Function usb_relay_init CDecl Lib "usb_relay_device.dll" () As Long
Private Declare Sub usb_relay_device_close CDecl Lib "usb_relay_device.dll" (ByVal hHandle As Long)

Private Declare Function usb_relay_device_open CDecl Lib "usb_relay_device.dll" (ByVal Device_Info As Long) As Long
Private Declare Function usb_relay_device_open_with_serial_number CDecl Lib "usb_relay_device.dll" (ByVal Serial_Number As Long, ByVal Length As Integer) As Long

Private Declare Function usb_relay_device_get_status CDecl Lib "usb_relay_device.dll" (ByVal hHandle As Long, ByRef Status As Long) As Long



'local variable to hold collection
Private mCol As Collection


Public Sub InitRelay()
    Debug.Print "InitRelay"

    
'    /*Finalize the USB Relay Libary.
'    This function frees all of the static data associated with
'    USB Relay Libary. It should be called at the end of execution to avoid
'    memory leaks.
'    @returns:This function returns 0 on success and -1 on error.
    Debug.Print "usb_relay_exit: " & IIf(usb_relay_exit = 0, "success", "error")
    
    
    
'    /*init the USB Relay Libary
'    @returns: This function returns 0 on success and -1 on error.
    Debug.Print "usb_relay_init: " & IIf(usb_relay_init = 0, "success", "error")


'   /*Enumerate the USB Relay Devices.*/
    Dim nRet_dev_enum As Long
    nRet_dev_enum = usb_relay_device_enumerate


    If Not (nRet_dev_enum > 0) Then
        Debug.Print "usb_relay_device_enumerate: " & "USB Relay Not Found!"
        'MsgBox "USB Relay Not Found!"
        Exit Sub
    Else
        Debug.Print "usb_relay_device_enumerate: success. " & " USB Relay Found."
    End If


    Dim nRet_next_dev As Long
    nRet_next_dev = nRet_dev_enum

    Dim dev_Info As USB_Relay_Device_Info
    Dim sSerial As String
    Dim sPath As String

    Dim nStatus As Long
    Dim nRet_dev_status As Long
    
    Dim nHandle As Long


    Do While nRet_next_dev > 0
    
        sSerial = ""
        sPath = ""
        
        dev_Info.Serial_Number = 0
        dev_Info.Device_Path = 0
        dev_Info.Device_Type = 0
        dev_Info.Next = 0
        
        
        CopyMemory ByVal VarPtr(dev_Info), ByVal nRet_next_dev, LenB(dev_Info)
        
        'Debug.Print "Serial_Number: " & dev_Info.Serial_Number
        'Debug.Print "Device_Path: " & dev_Info.Device_Path
        'Debug.Print "Type: " & dev_Info.Device_Type
        'Debug.Print "Next: " & dev_Info.Next
        

        sSerial = AToWP(dev_Info.Serial_Number, CP_ACP)
        sPath = AToWP(dev_Info.Device_Path, CP_ACP)
       
       
       nHandle = 0
       nHandle = usb_relay_device_open(nRet_next_dev)
       
        nStatus = 0
        nRet_dev_status = 0
'    status bit: High --> Low 0000 0000 0000 0000 0000 0000 0000 0000, one bit indicate a relay status.
'    the lowest bit 0 indicate relay one status, 1 -- means open status, 0 -- means closed status.
'    bit 0/1/2/3/4/5/6/7/8 indicate relay 1/2/3/4/5/6/7/8 status
'    @returns: 0 -- success; 1 -- error
'    int EXPORT_API usb_relay_device_get_status(int hHandle, unsigned int *status);
        nRet_dev_status = usb_relay_device_get_status(nHandle, nStatus)
        Debug.Print "usb_relay_device_get_status: " & IIf(nRet_dev_status = 0, "success", "error")
        
        Call usb_relay_device_close(nHandle)
       
       
        Me.Add sSerial, sPath, dev_Info.Device_Type, nStatus, sSerial
       
        Debug.Print "New Device: Serial: " & sSerial & "; Type: " & dev_Info.Device_Type & "; Status: " & nStatus
    
        nRet_next_dev = dev_Info.Next
    Loop

'    /*Free an enumeration Linked List*/
    Call usb_relay_device_free_enumerate(nRet_dev_enum)
    
End Sub










Public Function Add(Serial_Number As String, Device_Path As String, Relay_Type As Long, Relay_Status As Long, Optional sKey As String) As clsOneRelay
    'create a new object
    Dim objNewMember As clsOneRelay
    Set objNewMember = New clsOneRelay


    'set the properties passed into the method
    objNewMember.Serial_Number = Serial_Number
    objNewMember.Device_Path = Device_Path
    objNewMember.Relay_Type = Relay_Type
    objNewMember.Relay_Status = Relay_Status
    
    
    
    If Len(sKey) = 0 Then
        mCol.Add objNewMember
    Else
        mCol.Add objNewMember, sKey
    End If


    'return the object created
    Set Add = objNewMember
    Set objNewMember = Nothing


End Function

Public Property Get Item(vntIndexKey As Variant) As clsOneRelay
Attribute Item.VB_UserMemId = 0
  Set Item = mCol(vntIndexKey)
End Property



Public Property Get Count() As Long
    Count = mCol.Count
End Property


Public Sub Remove(vntIndexKey As Variant)
    mCol.Remove vntIndexKey
End Sub


Public Property Get NewEnum() As IUnknown
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"
    Set NewEnum = mCol.[_NewEnum]
End Property


Private Sub Class_Initialize()
    Set mCol = New Collection
    Call InitRelay
End Sub


Private Sub Class_Terminate()
    Debug.Print "Class_Terminate"
    Debug.Print "usb_relay_exit: " & IIf(usb_relay_exit = 0, "success", "error")
    
    Set mCol = Nothing
End Sub

